
/*

		gWX^Zp@QOOXNU

	WindowsAvP[VETvpt@[EFA


			Copyright 2009, Yoshi Hiroshi.

 */

#include <pic.h>

__CONFIG( UNPROTECT & LVPDIS & BOREN & MCLREN & PWRTDIS & WDTDIS & INTIO);

unsigned char previousPortdValue;
unsigned char commandReqFlag;
unsigned char commandBuff[4];
volatile unsigned char recieveBuff[4];
unsigned char recieveLength;
unsigned char sendBuff[6];
int sendLength;
unsigned char portVal = 0;
unsigned char ledPortVal;

void Init();
unsigned char RecieveCommand();
void DoCommand(unsigned char cmnd);
void CheckPortChange();
void SendResultData();void SetLedPort(int val);
unsigned char GetSwitch();
void LedTest();

#define GET_HEX_BYTE(h) ((((h) >= 'a')? ((h) - 'a' + 10):(((h) >= 'A')? ((h) - 'A' + 10):((h) - '0'))) & 0x0F)
#define GET_HEX_CHAR(h) (((h) > 9)? ((h) + 'A' - 10):((h) + '0'))

/*---------------------------------------------
 *
 *		C[`
 *
 */
int main()
{
	Init();
	LedTest();
	while(1)
	{
		commandReqFlag = RecieveCommand();		// R}h̎M
		if(commandReqFlag) DoCommand(commandReqFlag);			// R}h̎s
		if(sendLength <= 0) CheckPortChange();	// |[gω̃`FbN
		if(sendLength > 0) SendResultData();	// f[^̑M
	}
}

/*---------------------------------------------
 *
 *		
 *
 */
void Init()
{
	OPTION &= 0x7F;		// Pull ups on PORTB by defaul
	CMCON = 7;
	INTCON = 0;
	PIE1 = 0;

// Init PORTA as Output
	PORTA = 0xFF;
	TRISA = 0x20;			// MCLR
// Init PORTB as Inout
	PORTB = 0xFF;
	TRISB = 0x7B;			// LED6, TXD

// Init USART
	SPBRG = 25;							// 9600 baud
	BRGH  = 1;							// Hight BaudRate Generate
	TXEN = 1;							// Transimit Enable
	SPEN = 1;							// SerialPort Enable
	CREN = 1;

// Init Command Buffer
	recieveLength = 0;
	sendBuff[4] = 0x0D;
	sendBuff[5] = 0x0A;
	commandReqFlag = 0;
	sendLength = 0;
	previousPortdValue = GetSwitch();
}

/*---------------------------------------------
 *
 *		XBb`f[^̎擾
 *
 */
unsigned char GetSwitch()
{
	unsigned char work = PORTB;
	return (work & 0x78) | ((work  & 0x01) << 2);
}


/*---------------------------------------------
 *
 *		LED|[gf[^̎擾
 *
 */
unsigned char GetLedPort()
{
	return ledPortVal;
//	unsigned char work1 = PORTA;
//	unsigned char work2 = PORTB >> 2;
//	work1 &= 0xDF;
//	work2 &= 0x20;
//	return ~(work1 | work2);
}


/*---------------------------------------------
 *
 *		LED|[g֏o
 *
 */
void SetLedPort(int val)
{
	ledPortVal = val;
	PORTA = ~val | 0x20;
	if((val & 0x20) != 0)
	{
		PORTB &= 0x7F;
	}
	else
	{
		PORTB |= 0x80;
	}
}

/*---------------------------------------------
 *
 *		R}h̎M
 *
 */
unsigned char RecieveCommand()
{
	unsigned char result = 0;
	if(RCIF != 0)		// f[^MH
	{
		portVal = RCREG;
		switch(portVal)
		{
		case 0x0D:
		case 0x0A:					// CR/LFł̓obt@
			recieveLength = 0;
			break;
		default:
			if(recieveLength < 4)	// obt@TCYȓȂA
				recieveBuff[recieveLength++] = portVal;		// f[^obt@Ɋi[
			break;
		}
	}
	if(recieveLength > 1)
	{
		switch(recieveBuff[0])
		{
		case 'R':
		case 'r':
			if(recieveLength == 2) result = 'R';
			break;
		case 'W':
		case 'w':
			if(recieveLength == 4) result = 'W';
			break;
		default:
			break;
		}
	}
	if(result)
	{
		commandBuff[0] = recieveBuff[0];
		commandBuff[1] = recieveBuff[1];
		commandBuff[2] = recieveBuff[2];
		commandBuff[3] = recieveBuff[3];
		recieveLength = 0;
	}
	return result;
}


/*---------------------------------------------
 *
 *		R}h̎s
 *
 */
void DoCommand(unsigned char cmnd)
{
	unsigned char work1, work2;
	switch(cmnd)
	{
	case 'R':
	case 'r':
		if((commandBuff[1] == 'D') || (commandBuff[1] == 'd'))
		{
			portVal = GetSwitch();
			sendLength = 6;
			commandReqFlag = 0;
		}
		if((commandBuff[1] == 'B') || (commandBuff[1] == 'b'))
		{
			portVal = GetLedPort();
			sendLength = 6;
			commandReqFlag = 0;
		}
		sendBuff[0] = 'P';
		sendBuff[1] = commandBuff[1] & 0xDF;
		work1 = (portVal >> 4) & 0x0F;
		sendBuff[2] = GET_HEX_CHAR(work1);
		work2 = portVal & 0x0F;
		sendBuff[3] = GET_HEX_CHAR(work2);
		recieveLength = 0;
		break;
	case 'W':
	case 'w':
		if((commandBuff[1] == 'B') || (commandBuff[1] == 'b'))
		{
			work1 = commandBuff[2];
			work1 = GET_HEX_BYTE(work1) << 4;
			work2 = commandBuff[3];
			work2 = GET_HEX_BYTE(work2);
			portVal = work1 | work2;
			SetLedPort(portVal);
		}
		recieveLength = 0;
		break;
	default:
		break;
	}
}

/*---------------------------------------------
 *
 *		|[g̕ωo
 *
 */
void CheckPortChange()
{
	unsigned char work;
	if(previousPortdValue != GetSwitch())
	{
		previousPortdValue = GetSwitch();
		sendBuff[0] = 'C';
		sendBuff[1] = 'D';
		work = (previousPortdValue >> 4) & 0x0F;
		sendBuff[2] = GET_HEX_CHAR(work);
		work = previousPortdValue & 0x0F;
		sendBuff[3] = GET_HEX_CHAR(work);
		sendLength = 6;
	}
}

/*---------------------------------------------
 *
 *		f[^̑M
 *
 */
void SendResultData()
{
	if((TXIF) != 0)
	{
		portVal = sendBuff[6 - sendLength--];
		TXREG = portVal;
	}
}

/*---------------------------------------------
 *
 *		LED̕\eXg
 *
 */
void LedTest()
{
	unsigned char dataIndex = 0;
	short interval;
	unsigned char switchVal = GetSwitch();
	while((switchVal & 0x10) != 0)
	{
		interval = ((switchVal & 0x08) != 0) ? 10000:2500;
		interval = ((switchVal & 0x04) != 0) ? interval * 2:interval;
		SetLedPort(eeprom_read(dataIndex++));
		dataIndex &= 0xFF;
		for(unsigned int index = 0; index < interval; index++)
		{
		}
		switchVal = GetSwitch();
	}
	SetLedPort(0);
}

__EEPROM_DATA( 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0xFF, 0xFF );
__EEPROM_DATA( 0xFF, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFE );
__EEPROM_DATA( 0xFD, 0xFB, 0xF7, 0xEF, 0xDF, 0xBF, 0x7F, 0xBF );
__EEPROM_DATA( 0xDF, 0xEF, 0xF7, 0xFB, 0xFD, 0xFE, 0xFD, 0xFB );
__EEPROM_DATA( 0xF7, 0xEF, 0xDF, 0xBF, 0x7F, 0xBF, 0xDF, 0xEF );
__EEPROM_DATA( 0xF7, 0xFB, 0xFD, 0xFE, 0xFC, 0xF8, 0xF0, 0xE0 );
__EEPROM_DATA( 0xC0, 0x80, 0x00, 0x80, 0x40, 0x20, 0x10, 0x08 );
__EEPROM_DATA( 0x04, 0x02, 0x01, 0x02, 0x04, 0x08, 0x10, 0x20 );
__EEPROM_DATA( 0x40, 0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02 );
__EEPROM_DATA( 0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80 );
__EEPROM_DATA( 0x00, 0x80, 0xC0, 0xE0, 0xF0, 0xF8, 0xFC, 0xFE );
__EEPROM_DATA( 0xFF, 0x7F, 0x3F, 0x1F, 0x0F, 0x07, 0x03, 0x01);
__EEPROM_DATA( 0x00, 0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40 );
__EEPROM_DATA( 0x80, 0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40 );
__EEPROM_DATA( 0x80, 0x01, 0x03, 0x06, 0x0C, 0x18, 0x30, 0x60 );
__EEPROM_DATA( 0xC0, 0x80, 0x01, 0x02, 0x05, 0x0A, 0x14, 0x28 );
__EEPROM_DATA( 0x50, 0xA0, 0x41, 0x82, 0x04, 0x09, 0x12, 0x24 );
__EEPROM_DATA( 0x48, 0x90, 0x21, 0x42, 0x84, 0x08, 0x11, 0x22 );
__EEPROM_DATA( 0x44, 0x88, 0x11, 0x22, 0x44, 0x88, 0x10, 0x21 );
__EEPROM_DATA( 0x42, 0x84, 0x09, 0x12, 0x24, 0x48, 0x90, 0x20 );
__EEPROM_DATA( 0x41, 0x82, 0x05, 0x0A, 0x14, 0x28, 0x50, 0xA0 );
__EEPROM_DATA( 0x40, 0x81, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40 );
__EEPROM_DATA( 0x81, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80 );
__EEPROM_DATA( 0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80 );
__EEPROM_DATA( 0x01, 0x03, 0x06, 0x0C, 0x18, 0x30, 0x60, 0xC0 );
__EEPROM_DATA( 0x01, 0x03, 0x07, 0x0E, 0x1C, 0x38, 0xE0, 0xC0 );
__EEPROM_DATA( 0x01, 0x03, 0x07, 0x0E, 0x1F, 0x3E, 0x7C, 0xE8 );
__EEPROM_DATA( 0xF0, 0xE0, 0xC0, 0x80, 0x01, 0x03, 0x07, 0x0F );
__EEPROM_DATA( 0x1F, 0x3F, 0x7F, 0xFF, 0xFC, 0xF0, 0xE0, 0xC0 );
__EEPROM_DATA( 0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x01 );
__EEPROM_DATA( 0x80, 0xC0, 0x60, 0x30, 0x18, 0x0C, 0x06, 0x03 );
__EEPROM_DATA( 0x01, 0x80, 0xC0, 0xE0, 0xF0, 0xF8, 0xFC, 0xFE );


	